namespace IRDB_SDK
{
	class AddressID_t : virtual public BaseObj_t
	{
		protected:
			AddressID_t() {}
			AddressID_t(const AddressID_t& copy)=delete;

		public:
			virtual ~AddressID_t() {}

			virtual DatabaseID_t    getFileID()        const = 0;
			virtual VirtualOffset_t getVirtualOffset() const = 0;

			virtual void setFileID(DatabaseID_t thefileID)      = 0;
			virtual void setVirtualOffset(VirtualOffset_t voff) = 0;
	};

}
