

namespace IRDB_SDK
{
	using namespace std;
	using  SyscallNumber_t = enum SyscallNumber
		{
			sntUnknown=-1,
		};

	class  SyscallSite_t
	{
		protected:
			SyscallSite_t() { }
			SyscallSite_t(const SyscallSite_t& copy) = delete;
		public:
			virtual ~SyscallSite_t() { }
			virtual Instruction_t*  getSyscallSite()   const = 0 ;
			virtual Instruction_t*  getSite()          const = 0 ;
			virtual SyscallNumber_t getSyscallNumber() const = 0 ;
	};

	using SyscallSiteSet_t = set<SyscallSite_t*>;

	class Syscalls_t
	{
		protected:
			Syscalls_t() { }
			Syscalls_t(const Syscalls_t& copy) = delete;
		public:
			virtual ~Syscalls_t() { }
		// getters
			virtual const SyscallSiteSet_t& getSyscalls() const = 0;
		// factories
			static unique_ptr<Syscalls_t> factory(FileIR_t *the_firp); 
	};

}

