namespace IRDB_SDK
{

	class ArchitectureDescription_t
	{
		protected:
			ArchitectureDescription_t() {}
			ArchitectureDescription_t(const ArchitectureDescription_t& copy) = delete;
		public:
			~ArchitectureDescription_t() {}

			virtual int             getBitWidth()    const = 0;
			virtual ADFileType_t    getFileType()    const = 0;
			virtual ADMachineType_t getMachineType() const = 0;

			virtual void setFileType(const ADFileType_t t)       = 0;
			virtual void setBitWidth(const int _bits)            = 0;
			virtual void setMachineType(const ADMachineType_t t) = 0;

	};

}
