
#include <irdb-core>

namespace IRDB_SDK 
{

using namespace std;

Instruction_t* insertAssemblyBefore   (FileIR_t* firp, Instruction_t* before, string assembly, Instruction_t *target=nullptr);
Instruction_t* insertAssemblyAfter    (FileIR_t* firp, Instruction_t* after , string assembly, Instruction_t *target=nullptr);
Instruction_t* insertDataBitsBefore   (FileIR_t* firp, Instruction_t* before, string dataBits, Instruction_t *target=nullptr);
Instruction_t* insertDataBitsAfter    (FileIR_t* firp, Instruction_t* after , string dataBits, Instruction_t *target=nullptr);

Instruction_t* addNewDataBits         (FileIR_t* firp, string p_bits);
Instruction_t* addNewAssembly         (FileIR_t* firp, string p_asm);
Instruction_t* addNewDataBits         (FileIR_t* firp, Instruction_t* p_after, string p_bits);
Instruction_t* addNewAssembly         (FileIR_t* firp, Instruction_t* p_after, string p_asm);

void setInstructionAssembly(
		FileIR_t* firp, 
		Instruction_t* instr, 
		const string& p_asm, 
		Instruction_t *p_new_fallthrough, 
		Instruction_t* p_new_target=nullptr);
void setInstructionAssembly(FileIR_t* firp, Instruction_t* instr, const string& p_asm);


}
