namespace IRDB_SDK
{

	class InstructionPredecessors_t
	{
		protected:
			InstructionPredecessors_t() { }
			InstructionPredecessors_t(const InstructionPredecessors_t& copy) = delete;
		public:
			virtual ~InstructionPredecessors_t() { } 

		// getters
			virtual const InstructionSet_t& getPredecessors(const Instruction_t* i)  const = 0;
			virtual const InstructionSet_t& operator[] (const Instruction_t* i)     const = 0;

		// factories
			static unique_ptr<InstructionPredecessors_t> factory(FileIR_t* firp=nullptr);

	};

}
